about summary refs log tree commit diff
diff options
context:
space:
mode:
authorJune McEnroe <june@causal.agency>2021-09-27 19:16:45 +0000
committerJune McEnroe <june@causal.agency>2021-09-27 19:16:45 +0000
commit54c632e8c35c3283a890c589f1b7937887c13877 (patch)
tree114f6410374a7c2e6b18e15e425a26aae23d6ebc
parentRequest znc.in/self-message if available (diff)
downloadcatgirl-54c632e8c35c3283a890c589f1b7937887c13877.tar.gz
catgirl-54c632e8c35c3283a890c589f1b7937887c13877.zip
chroot: Factor out and add OpenBSD build
-rw-r--r--Makefile31
-rw-r--r--README.75
-rw-r--r--scripts/build-chroot.sh74
3 files changed, 82 insertions, 28 deletions
diff --git a/Makefile b/Makefile
index 373e7d5..48fc350 100644
--- a/Makefile
+++ b/Makefile
@@ -63,36 +63,11 @@ CHROOT_USER = chat
 CHROOT_GROUP = ${CHROOT_USER}
 
 chroot.tar: catgirl catgirl.1 scripts/chroot-prompt.sh scripts/chroot-man.sh
-	install -d -o root -g wheel \
-		root \
-		root/bin \
-		root/etc \
-		root/home \
-		root/lib \
-		root/libexec \
-		root/usr/bin \
-		root/usr/local/etc/ssl \
-		root/usr/share/man \
-		root/usr/share/misc
-	install -d -o ${CHROOT_USER} -g ${CHROOT_GROUP} \
-		root/home/${CHROOT_USER} \
-		root/home/${CHROOT_USER}/.local/share
-	cp -fp /libexec/ld-elf.so.1 root/libexec
-	ldd -f '%p\n' catgirl /usr/bin/mandoc /usr/bin/less \
-		| sort -u | xargs -t -J % cp -fp % root/lib
-	chflags noschg root/libexec/* root/lib/*
-	cp -fp /etc/hosts /etc/resolv.conf root/etc
-	cp -fp /usr/local/etc/ssl/cert.pem root/usr/local/etc/ssl
-	cp -af /usr/share/locale root/usr/share
-	cp -fp /usr/share/misc/termcap.db root/usr/share/misc
-	cp -fp /rescue/sh /usr/bin/mandoc /usr/bin/less root/bin
-	${MAKE} install DESTDIR=root PREFIX=/usr MANDIR=/usr/share/man
-	install scripts/chroot-prompt.sh root/usr/bin/catgirl-prompt
-	install scripts/chroot-man.sh root/usr/bin/man
-	tar -c -f chroot.tar -C root bin etc home lib libexec usr
+chroot.tar: scripts/build-chroot.sh
+	sh scripts/build-chroot.sh ${CHROOT_USER} ${CHROOT_GROUP}
 
 install-chroot: chroot.tar
-	tar -x -f chroot.tar -C /home/${CHROOT_USER}
+	tar -px -f chroot.tar -C /home/${CHROOT_USER}
 
 clean-chroot:
 	rm -fr chroot.tar root
diff --git a/README.7 b/README.7
index 2179225..c717aa9 100644
--- a/README.7
+++ b/README.7
@@ -215,6 +215,11 @@ sleep/wake wrapper for macOS
 .It Pa scripts/notify-send.scpt
 .Xr notify-send 1
 in AppleScript
+.It Pa scripts/build-chroot.sh
+chroot builder for
+.Ox
+and
+.Fx
 .It Pa scripts/chroot-prompt.sh
 name prompt wrapper for chroot
 .It Pa scripts/chroot-man.sh
diff --git a/scripts/build-chroot.sh b/scripts/build-chroot.sh
new file mode 100644
index 0000000..a0fcf32
--- /dev/null
+++ b/scripts/build-chroot.sh
@@ -0,0 +1,74 @@
+#!/bin/sh
+set -eux
+
+CHROOT_USER=$1
+CHROOT_GROUP=$2
+
+if [ "$(uname)" = 'OpenBSD' ]; then
+	install -d -o root -g wheel \
+		root \
+		root/bin \
+		root/etc/ssl \
+		root/home \
+		root/usr/bin \
+		root/usr/lib \
+		root/usr/libexec \
+		root/usr/share/man
+	install -d -o ${CHROOT_USER} -g ${CHROOT_GROUP} \
+		root/home/${CHROOT_USER} \
+		root/home/${CHROOT_USER}/.local/share
+
+	cp -fp /bin/sh root/bin
+	cp -fp /usr/libexec/ld.so root/usr/libexec
+	export LD_TRACE_LOADED_OBJECTS_FMT1='%p\n'
+	export LD_TRACE_LOADED_OBJECTS_FMT2=''
+	for bin in ./catgirl /usr/bin/mandoc /usr/bin/less; do
+		LD_TRACE_LOADED_OBJECTS=1 $bin | xargs -t -J % cp -fp % root/usr/lib
+	done
+	cp -fp /usr/bin/printf /usr/bin/mandoc /usr/bin/less root/usr/bin
+	make install DESTDIR=root PREFIX=/usr MANDIR=/usr/share/man
+	install scripts/chroot-prompt.sh root/usr/bin/catgirl-prompt
+	install scripts/chroot-man.sh root/usr/bin/man
+
+	cp -fp /etc/hosts /etc/resolv.conf root/etc
+	cp -fp /etc/ssl/cert.pem root/etc/ssl
+	cp -af /usr/share/locale /usr/share/terminfo root/usr/share
+
+	tar -c -f chroot.tar -C root bin etc home usr
+
+elif [ "$(uname)" = 'FreeBSD' ]; then
+	install -d -o root -g wheel \
+		root \
+		root/bin \
+		root/etc \
+		root/home \
+		root/lib \
+		root/libexec \
+		root/usr/bin \
+		root/usr/local/etc/ssl \
+		root/usr/share/man \
+		root/usr/share/misc
+	install -d -o ${CHROOT_USER} -g ${CHROOT_GROUP} \
+		root/home/${CHROOT_USER} \
+		root/home/${CHROOT_USER}/.local/share
+
+	cp -fp /libexec/ld-elf.so.1 root/libexec
+	ldd -f '%p\n' catgirl /usr/bin/mandoc /usr/bin/less \
+		| sort -u | xargs -t -J % cp -fp % root/lib
+	chflags noschg root/libexec/* root/lib/*
+	cp -fp /rescue/sh /usr/bin/mandoc /usr/bin/less root/bin
+	make install DESTDIR=root PREFIX=/usr MANDIR=/usr/share/man
+	install scripts/chroot-prompt.sh root/usr/bin/catgirl-prompt
+	install scripts/chroot-man.sh root/usr/bin/man
+
+	cp -fp /etc/hosts /etc/resolv.conf root/etc
+	cp -fp /usr/local/etc/ssl/cert.pem root/usr/local/etc/ssl
+	cp -af /usr/share/locale root/usr/share
+	cp -fp /usr/share/misc/termcap.db root/usr/share/misc
+
+	tar -c -f chroot.tar -C root bin etc home lib libexec usr
+
+else
+	echo "Don't know how to build chroot on $(uname)" >&2
+	exit 1
+fi